//+------------------------------------------------------------------+
//| _I_VVA_MACD2_1_0.mq4 |
//| Copyright 2009, MetaQuotes Software Corp. |
//| http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2009, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"

//
//    D
// 1.    /
// 2.     


//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 OrangeRed
#property indicator_color3 Silver
#property indicator_color4 Blue

#property indicator_width1 2
#property indicator_width2 2

//---- indicator parameters

//
extern string _sFast = " MA-----------------------------";
extern int _FastMA=12;
extern string _sFastMode = "0=SMA/1=EMA/2=SMMA/3=LWMA";
extern int _FastMode=1;
extern string _sFastPrice = "0=CLOSE/1=OPEN/2=HIGH/3=LOW/4=MEDIAN/5=TYPICAL/6=WEIGHTED";
extern int _FastPrice=0;
//
extern string _sSlow = " MA-----------------------------";
extern int _SlowMA=26;
extern string _sSlowMode = "0=SMA/1=EMA/2=SMMA/3=LWMA";
extern int _SlowMode=1;
extern string _sSlowPrice = "0=CLOSE/1=OPEN/2=HIGH/3=LOW/4=MEDIAN/5=TYPICAL/6=WEIGHTED";
extern int _SlowPrice=0;
//
extern string _sSignal = " MA-----------------------------";
extern int _SignalMA=9;
extern string _sSignalMode = "0=SMA/1=EMA/2=SMMA/3=LWMA";
extern int _SignalMode=1;

// 0 
extern string _sShowBar0 = " 0 -----------------------------";
extern bool _bShowBar0= true;

//---- indicator buffers
double MacdBuffer[], MacdBufferUp[], MacdBufferDown[];
double SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
  //---- drawing settings
  IndicatorBuffers(4);
  IndicatorDigits(Digits+3);
  
  SetIndexBuffer (0,MacdBufferUp);
  SetIndexStyle (0,DRAW_HISTOGRAM);
  SetIndexEmptyValue(0,0.0);

  SetIndexBuffer (1,MacdBufferDown);
  SetIndexStyle (1,DRAW_HISTOGRAM);
  SetIndexEmptyValue(1,0.0);

  SetIndexBuffer (2,SignalBuffer);
  SetIndexStyle (2,DRAW_LINE);
  SetIndexDrawBegin(2,_SignalMA);
  SetIndexEmptyValue(2,0.0);

  SetIndexBuffer (3,MacdBuffer);
  SetIndexStyle (3,DRAW_LINE);
  SetIndexEmptyValue(3,0.0);

  SetIndexLabel (0,"0 Up");
  SetIndexLabel (1,"1 Down");
  SetIndexLabel (2,"2 Signal");
  SetIndexLabel (3,"3 Macd");

  IndicatorShortName(
    "MACD2("+_FastMA+","+_SlowMA+","+_SignalMA+")");

  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
  //----

  //----
  return(0);
}
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence |
//+------------------------------------------------------------------+
int start()
{
  int limit,i;
  int counted_bars=IndicatorCounted();
  //---- last counted bar will be recounted
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  //---- macd counted in the 1-st buffer
  
  for(i=0; i<limit; i++)
  {
    MacdBuffer[i]=
      iMA(NULL,0,_FastMA,0,_FastMode,_FastPrice,i)
      -iMA(NULL,0,_SlowMA,0,_SlowMode,_SlowPrice,i);
  }
  
  for(i=0; i<limit; i++)
  {
    SignalBuffer[i]=
      iMAOnArray(MacdBuffer,Bars,_SignalMA,0,_SignalMode,i);
  }

  /*
  for(i=0; i<limit; i++)
  {
    MacdBufferDown[i]=0.0; MacdBufferUp[i]=0.0;

    //      //break the null bar
    if(i>=1 || _bShowBar0)
    {
      //  //condition of color
      if(MacdBuffer[i+1]-MacdBuffer[i]>=0)
        MacdBufferDown[i]=MacdBuffer[i];
      else
        MacdBufferUp[i]=MacdBuffer[i];
    }
  }
  */
  double current, prev;
  for(i=0; i<limit; i++)
  {

    MacdBufferUp[i] = 0;
    MacdBufferDown[i] = 0;
    current = MacdBuffer[i] - SignalBuffer[i];
    prev = MacdBuffer[i+1] - SignalBuffer[i+1];

    //      //break the null bar
    if(i>=1 || _bShowBar0)
    {

      if (current > prev)
      {
        MacdBufferUp[i] = current;
        MacdBufferDown[i] = 0.0;
      }
      else
      {
        MacdBufferDown[i] = current;
        MacdBufferUp[i] = 0.0;
      }

    }

  }

  return(0);
}
//+------------------------------------------------------------------+
